<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/type.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/type.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/type.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP variable type. Type can be a class or primitive data type.
<a name="line22"></a> *
<a name="line23"></a> * @package PHPDoctor
<a name="line24"></a> */
<a name="line25"></a>class Type
<a name="line26"></a>{
<a name="line27"></a>
<a name="line28"></a>	/** The name of the type.
<a name="line29"></a>	 *
<a name="line30"></a>	 * @var str
<a name="line31"></a>	 */
<a name="line32"></a>	var $_name = NULL;
<a name="line33"></a>
<a name="line34"></a>	/** The number of dimensions this type has.
<a name="line35"></a>	 *
<a name="line36"></a>	 * @var int
<a name="line37"></a>	 */
<a name="line38"></a>	var $_dimension = 0;
<a name="line39"></a>
<a name="line40"></a>	/** Reference to the root element.
<a name="line41"></a>	 *
<a name="line42"></a>	 * @var rootDoc
<a name="line43"></a>	 */
<a name="line44"></a>	var $_root = NULL;
<a name="line45"></a>
<a name="line46"></a>	/** Constructor
<a name="line47"></a>     *
<a name="line48"></a>     * @param str name The name of the variable type
<a name="line49"></a>     * @param RootDoc root The RootDoc object to tie this type too
<a name="line50"></a>	 */
<a name="line51"></a>	function type($name, &$root)
<a name="line52"></a>    {
<a name="line53"></a>		while (substr($name, -2) == '[]') {
<a name="line54"></a>			$this->_dimension++;
<a name="line55"></a>			$name = substr($name, 0, -2);
<a name="line56"></a>		}
<a name="line57"></a>		$this->_name = $name;
<a name="line58"></a>		$this->_root =& $root;
<a name="line59"></a>	}
<a name="line60"></a>
<a name="line61"></a>	/** Get name of this type.
<a name="line62"></a>	 *
<a name="line63"></a>	 * @return str
<a name="line64"></a>	 */
<a name="line65"></a>	function typeName()
<a name="line66"></a>    {
<a name="line67"></a>		return $this->_name;
<a name="line68"></a>	}
<a name="line69"></a>
<a name="line70"></a>	/** Return the type's dimension information, as a string.
<a name="line71"></a>	 *
<a name="line72"></a>	 * @return str
<a name="line73"></a>	 */
<a name="line74"></a>	function dimension()
<a name="line75"></a>    {
<a name="line76"></a>		return str_repeat('[]', $this->_dimension);
<a name="line77"></a>	}
<a name="line78"></a>
<a name="line79"></a>	/** Get qualified name of this type.
<a name="line80"></a>	 *
<a name="line81"></a>	 * @return str
<a name="line82"></a>     * @todo This method is still to be implemented
<a name="line83"></a>	 */
<a name="line84"></a>	function qualifiedTypeName()
<a name="line85"></a>    {
<a name="line86"></a>        return $this->typeName();
<a name="line87"></a>    }
<a name="line88"></a>
<a name="line89"></a>	/** Returns a string representation of the type.
<a name="line90"></a>	 *
<a name="line91"></a>	 * @return str
<a name="line92"></a>	 */
<a name="line93"></a>	function toString()
<a name="line94"></a>    {
<a name="line95"></a>		return $this->_name.$this->dimension();
<a name="line96"></a>	}
<a name="line97"></a>
<a name="line98"></a>	/** Return this type as a class.
<a name="line99"></a>	 *
<a name="line100"></a>	 * @return ClassDoc A classDoc if the type is a class, null if it is a primitive type.
<a name="line101"></a>	 */
<a name="line102"></a>	function &asClassDoc()
<a name="line103"></a>    {
<a name="line104"></a>		return $this->_root->classNamed($this->_name);
<a name="line105"></a>	}
<a name="line106"></a>
<a name="line107"></a>}
<a name="line108"></a>
<a name="line109"></a>?>
<a name="line110"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/type.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>